// Server.java
import Bank.nameUtils;


import java.util.*;

class Account extends org.omg.CORBA.DynamicImplementation {
  static final String[] _ob_ids_ =
    {
        "IDL:Account:1.0",
    };
 
    public String[]
    _ids()
    {
        return _ob_ids_;
    }

  Account(float balance) {
    //super(null, "IDL:Bank/Account:1.0");
    _balance = balance;
  }
  public void invoke(org.omg.CORBA.ServerRequest request) {
    // make the operation name is correct
    if(!request.op_name().equals("balance")) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    //test something
    org.omg.CORBA.Request req = _request(request.op_name());
    System.out.println("operation of request :"+req.operation());
    org.omg.CORBA.NVList nvl = req.arguments();
    System.out.println("operation has :"+nvl.count()+" params");
    for(int k=0;k<nvl.count();k++){
      try{
	System.out.println("name of param:"+nvl.item(k).name());
	System.out.println("its flag:"+nvl.item(k).flags());
      }catch(org.omg.CORBA.Bounds e){
	System.out.println("org.omg.CORBA.Bounds :"+e);
      }
    }
    
        


    // no parameters, so simply invoke the balance operation
    float balance = this.balance();
    // create an any for the result
     org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
    org.omg.CORBA.Any balanceAny = _ob_orb.create_any();
    // put in the balance, 
    balanceAny.insert_float(balance);
    // set the request's result
    request.result(balanceAny);
  }
  float balance() {
    return _balance;
  }
  private float _balance;
}

class AccountManager extends org.omg.CORBA.DynamicImplementation {
  static final String[] _ob_ids_ =
    {
        "IDL:AccountManager:1.0",
    };
 
    public String[]
    _ids()
    {
        return _ob_ids_;
    }
  AccountManager(String name) {
    //super(name, "IDL:Bank/AccountManager:1.0");
  }
  public void invoke(org.omg.CORBA.ServerRequest request) {

     // create an empty parameter list
    org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
    org.omg.CORBA.NVList params = _ob_orb.create_list(0);
    String _ob_op = request.op_name();
   
    //test
    if(_ob_op.equals("open"))
      {
       
	    // create an any for the name parameter
	org.omg.CORBA.Any nameAny = _ob_orb.create_any();
	// set the any's type to be a string
	nameAny.type(_ob_orb.get_primitive_tc(
		org.omg.CORBA.TCKind.tk_string));
	// add "in" the parameter to the parameter list
	params.add_value("name", nameAny, org.omg.CORBA.ARG_IN.value);
	// obtains the params from the request
	request.params(params);
	// get the name parameter from the any
	String name = nameAny.extract_string();
	// invoke the open operation
	Account account = this.open(name);
	// create an any for the result
	org.omg.CORBA.Any accountAny = _ob_orb.create_any();
	// put in the new account object
	accountAny.insert_Object(account);
	// set the request's result
	request.result(accountAny);

	//test something
	org.omg.CORBA.Request req = _request(request.op_name());
	System.out.println("operation of request :"+req.operation());
	org.omg.CORBA.NVList nvl = req.arguments();
	System.out.println("operation has :"+nvl.count()+" params");
	for(int k=0;k<nvl.count();k++){
	  try{
	    System.out.println("name of param:"+nvl.item(k).name());
	    System.out.println("its flag:"+nvl.item(k).flags());
	  }catch(org.omg.CORBA.Bounds e){
	    System.out.println("org.omg.CORBA.Bounds :"+e);
	  }
	}
      }
      else if (_ob_op.equals("request"))
	{
	  // create an any for the name parameter
	  org.omg.CORBA.Any nameAny = _ob_orb.create_any();
	  // set the any's type to be a string
	  nameAny.type(_ob_orb.get_primitive_tc(
			      		org.omg.CORBA.TCKind.tk_any));

	  // add "in" the parameter to the parameter list
	  params.add_value("request", nameAny, org.omg.CORBA.ARG_IN.value);
	  // obtains the params from the request
	  request.params(params);
	  // get the name parameter from the any
	  org.omg.CORBA.Any req = nameAny.extract_any();
          org.omg.CORBA.Request inreq = (org.omg.CORBA.Request)req.extract_Object();
	  
	  //print some diagnostic
	  System.out.println("operation :"+inreq.operation());
	  
	  
	}
    

    else {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
  }
  public synchronized Account open(String name) {
    // Lookup the account in the account dictionary.
    Account account = (Account) _accounts.get(name);
    if(account == null) {
      // Create a new account with between 0 and 1000 dollars.
      float balance = Math.abs(_random.nextInt()) % 100000 / 100f;
      account = new Account(balance);
      // Export the new object reference.
      org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
      //org.omg.CORBA.BOA _ob_boa = _ob_orb.BOA_init();
      //_ob_boa.impl_is_ready(null);//account);
      System.out.println("Created " + name + "'s account: " + account);
      // Save the account in the account dictionary.
      _accounts.put(name, account);
    }
    // Return the account.
    return account;
  }
  private Dictionary _accounts = new Hashtable();
  private Random _random = new Random();
}

public class Server1 {
  public static void main(String[] args) {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,new java.util.Properties());
    // Initialize the BOA.
    org.omg.CORBA.BOA boa = orb.BOA_init(args,null);
    // Create the account manager object.
    AccountManager manager = 
      new AccountManager("BankManager");
    nameUtils nu = new Bank.nameUtils(orb);
    nu.registerName("manager","",manager);
    
    // Export the newly create object.
    boa.impl_is_ready(null);
    System.out.println(manager + " is ready.");
    // Wait for incoming requests
    boa.impl_is_ready(null);
  }

}

