// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package first;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;

public class Client 
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
      if(args.length < 1)
	{
	  System.out.println("enter Server name to connect !!!!");
	  return;
	}
      
	  
	try
	{

	    Hello hello =null;
	  
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //find the Object & get its referrence    
	    nameUtils nutil = new nameUtils(orb);
	    hello = HelloHelper.narrow(nutil.findServer(args[0]));
            
	    System.out.println("I got HelloServer Object!!!");
	    
	   	    
	    //
	    // Main loop
	    //
	    System.out.println("Enter 'h' for hello or 'x' for exit:");

	    int c;

	    try
	    {
		String input;
		do
		{
		    System.out.print("> ");
		    DataInputStream dataIn = new DataInputStream(System.in);
		    BufferedReader in =
			new BufferedReader(new InputStreamReader(dataIn));
		    input = in.readLine();

		    if(input.equals("h")){
		      String  byeStr = hello.giveBye();
		      hello.sayBye(byeStr);
		    }
		    
		}
		while(!input.equals("x"));
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    System.exit(0);
	}
	catch(COMM_FAILURE ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
      
}
