// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package first;

import org.omg.CORBA.*;
import java.io.*;
import org.omg.CosNaming.*;

public class Server
{
    public static void main(String args[])
    {
	try
	{
            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, new java.util.Properties());
	    BOA boa = orb.BOA_init(args, new java.util.Properties());

	    //
	    // Create implementation object
	    //
	    Hello_impl hello_impl = new Hello_impl(orb);
            
	    //Write its IOR also into file for applet to use
	     //
            // Save reference
            //
            try
            {
                String ref = orb.object_to_string(hello_impl);
                String refFile = "Hello.ref";
                FileOutputStream file = new FileOutputStream(refFile);
                PrintWriter out = new PrintWriter(file);
                out.println(ref);
                out.flush();
                file.close();
            }
            catch(IOException ex)
            {
                System.err.println("Can't write to `" +
                                   ex.getMessage() + "'");
                System.exit(1);
            }
 
            //
            // Save reference as html
            //
            try
            {
                String ref = orb.object_to_string(hello_impl);
                String refFile = "Hello.html";
                FileOutputStream file = new FileOutputStream(refFile);
                PrintWriter out = new PrintWriter(file);
                out.println("<applet " +
                            "code=\"first/Client1.class\" " +
                            "archive=\"OB.jar\" " + "width=500 height=300>");
                out.println("<param name=ior value=\"" + ref + "\">");
                out.println("<param name=org.omg.CORBA.ORBClass " +
                            "value=com.ooc.CORBA.ORB>");
                out.println("<param name=org.omg.CORBA.ORBSingletonClass " +
                            "value=com.ooc.CORBA.ORBSingleton>");
                out.println("</applet>");
                out.flush();
                file.close();
            }
            catch(IOException ex)
            {
                System.err.println("Can't write to `" +
                                   ex.getMessage() + "'");
                System.exit(1);
            }
	    
	    ///





	    //Named Servants
	    //((com.ooc.CORBA.ORB)orb).connect(hello_impl,"HelloServer");
	    nameUtils nutil = new nameUtils(orb);
	    
	    nutil.registerName("HelloServer",hello_impl);
	    System.out.println("I registered HelloWorld Servlet !!!");
	    
	    //
	    // Run implementation
	    //
	    boa.impl_is_ready(null);

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
    
}

