package first;

import org.omg.CORBA.*;
import java.io.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;


class nameUtils 
{
  ORB orb;
     
public nameUtils(ORB orb_)
  {
     orb = orb_;
   }

 public void registerName(String serverName,org.omg.CORBA.Object obj)
  {

    NamingContext nc = null;
    try{
      nc = NamingContextHelper.narrow(
			      orb.resolve_initial_references("NameService") );
    }catch(org.omg.CORBA.ORBPackage.InvalidName e){
      System.out.println("We could not found nameServer:"+e);
    }

    try{
      NameComponent[] oneName = new NameComponent[1];
      oneName[0] = new NameComponent( serverName,"service");
      nc.bind(oneName, obj);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println(")");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound ex)
      {
	System.err.println("Got an `AlreadyBound' exception");
	ex.printStackTrace();
	
      }
      
  }

public  org.omg.CORBA.Object findServer(String serverName)
  {
    
    org.omg.CORBA.Object obj = null;
    
    NamingContext nc = null;
    try{
      nc = NamingContextHelper.narrow(
			   orb.resolve_initial_references("NameService"));
    }catch(org.omg.CORBA.ORBPackage.InvalidName e){
      System.out.println("We could not found nameServer:"+e);
    }
	    
	    
    // find an object (standard COSS naming interface)
 
    NameComponent[] components = new NameComponent[1];
    components[0] = new NameComponent(serverName,"service");
    try{
      obj = nc.resolve(components);
    }catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){
      System.out.println("InvalidName:"+serverName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){
      System.out.println("CannotProceed :"+serverName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound e){
      System.out.println("NotFound:"+serverName+":"+e);
    }
    return obj;
    
  }

}


