package core;
import org.omg.CORBA.Any;
import org.omg.CORBA.TCKind;
import  java.util.*;

public abstract class actorImpl extends _actorImplBase
{
  protected Hashtable incomingVals;
  protected Hashtable InPort,OutPort;
  protected Vector    orderedIn;
  
  public org.omg.CORBA.ORB   orb;
public org.omg.CORBA.BOA boa;
  
  public String myName;
  int InConns,OutConns;
  int numOfInput ;
  nameUtils NameServer;
    
public actorImpl(String myName_,String []args)
  {
    incomingVals = new Hashtable();
    InPort       = new Hashtable();
    orderedIn    = new Vector();
    OutPort      = new Hashtable();
    orb          = org.omg.CORBA.ORB.init(args, new java.util.Properties());
    boa          = orb.BOA_init(args, new java.util.Properties());
    NameServer   = new nameUtils(orb);
    myName       = myName_;
    InConns      = 0;
    OutConns     = 0;
    numOfInput   = 0;
    
  }
  
public void connectTo(actor toActor,String actorName)
  {
    System.out.println("Actor:"+myName+" connects to :"+actorName);
    
    OutPort.put(actorName,toActor);
    toActor.connectFrom(this,myName);
    OutConns++;   
  }
  //We need to preserve the connection orders to this actor
  //so that user should get ordered input data elements  
public void connectFrom(actor fromActor,String actorName)
  {
    System.out.println("Actor:"+myName +" connects from  :"+actorName);
    orderedIn.addElement(actorName);
    InPort.put(actorName,fromActor);
    InConns++;
  }

public void disconnectTo(actor toActor,String actorName)
  {
    OutPort.remove(actorName);
    toActor.disconnectFrom(this,myName);
    OutConns--;
  }
  
public void disconnectFrom(actor fromActor,String actorName)
  {
    orderedIn.removeElement(actorName);
    InPort.remove(actorName);
    InConns--;
  }

public abstract  Any  compute(Hashtable inputTable,Vector orderedIn);
  
public void  readIncoming(String actorName,Any input)
  {
    incomingVals.put( actorName,input);
    numOfInput ++;
    System.out.println(myName+" GOT new input from :"+actorName+
		       "numOfInput :"+numOfInput+" InConns:"+InConns);
            
    //We received data  from all of the input ports and do calculation
    if ((InConns > 0) && (numOfInput == InConns)){
      Any result = compute(incomingVals,orderedIn);
      Enumeration targets = OutPort.elements();
      while(targets.hasMoreElements()){
	actor dest = (actor)targets.nextElement();
	dest.readIncoming(myName,result);
      }
      //reset the input variables
      numOfInput = 0;
      incomingVals.clear();
    }
  }

public void trigger()
  {
    //First calculate over whatever data it has
    //and push the result to all of the actors connected with
    //this actor OutPort
    //Pay attention here. "USER" compute function should be written
    //such that if no values available(incomingVals does not have any item)
    //it will initialize itself and push the result
 
    System.out.println(myName+" IS TRIGGERED ");
    Any result = compute(incomingVals,orderedIn);
    Enumeration targets = OutPort.elements();
    while(targets.hasMoreElements()){
      actor dest = (actor)targets.nextElement();
      dest.readIncoming(myName,result);
    }

    
  }
  
public void disconnect_actor()
  {
    System.out.println("Actor :"+myName+" destroy itself");
    
    NameServer.unregisterActor(myName);
    orb.disconnect(this);
  }

public void destroy()
  {
    System.out.println("Actor :"+myName+" destroy itself");
    //just unbind actor       
    NameServer.unregisterActor(myName);
    try{
      boa.deactivate_impl(null);
    }catch(org.omg.CORBA.COMM_FAILURE e){
      System.out.println("CORBA.COMM_FAILURE : Forget this exception !!!");
    }
  }
  
}
