package factory;
import java.util.*;
import java.lang.*;

public class FactoryImpl  extends _FactoryImplBase
{
  org.omg.CORBA.ORB orb;
  org.omg.CORBA.BOA boa;
  Hashtable products;
  
  
  public FactoryImpl(org.omg.CORBA.ORB orb_,org.omg.CORBA.BOA boa_)
  {
    orb = orb_;
    boa = boa_;
    products = new Hashtable();
    
  }
  
  public void createProduct(String className,String serverName)
  {
    Class implClass       = null;
    org.omg.CORBA.Object obj  = null;

    try{
      implClass = Class.forName(className);
    }catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException : "+className+": "+e);
    }
     
    try{
      obj = (org.omg.CORBA.Object)implClass.newInstance() ;
    }catch (IllegalAccessException e){
    System.out.println("IllegalAccessException :"+className+": "+e);
    }
    catch(InstantiationException e){
      System.out.println("InstantiationException :"+className+": "+e);
    }   
 
    //connect it to object adapter
    orb.connect(obj);
    System.out.println("named_obj_is_ready for :"+className);

    //add into product hash table
    products.put(serverName,obj);

    //register it to name server
    nameUtils nutil = new nameUtils(orb);
    nutil.registerName(serverName,obj);
  }

  //deactivate the server factory started before      
  public void destroy(String serverName)
  {
    org.omg.CORBA.Object obj = (org.omg.CORBA.Object)products.get(serverName);
    orb.disconnect(obj);
    System.out.println("We deactivated the server :"+serverName);
  }
  
  public void readInClassAndServerNames(String fileName)
  {
    ;
  }
    
}
