package core;
import java.util.*;
import java.lang.*;

public class moduleFactoryImpl  extends _moduleFactoryImplBase
{
  org.omg.CORBA.ORB orb;
  org.omg.CORBA.BOA boa;
  Hashtable products;
  nameUtils NameServer;
  
  public moduleFactoryImpl(org.omg.CORBA.ORB orb_,org.omg.CORBA.BOA boa_)
  {
    orb = orb_;
    boa = boa_;
    products = new Hashtable();
    NameServer   = new nameUtils(orb);
  }
  
  public actor createProduct(String className,String serverName)
  {
    Class implClass       = null;
    org.omg.CORBA.Object obj  = null;

    try{
      implClass = Class.forName(className);
    }catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException : "+className+": "+e);
    }
     
    try{
      obj = (org.omg.CORBA.Object)implClass.newInstance() ;
    }catch (IllegalAccessException e){
    System.out.println("IllegalAccessException :"+className+": "+e);
    }
    catch(InstantiationException e){
      System.out.println("InstantiationException :"+className+": "+e);
    }   
 
    //connect it to object adapter
    orb.connect(obj);
    System.out.println("connect it to object adapter :"+className);

    //add into product hash table
    products.put(serverName,obj);
    System.out.println("add into product hash table :"+className);

    //register it to name server
    NameServer.registerName(serverName,obj);
    System.out.println("register it to name server:"+className);

    //return the created product,one actor
    return (actor)obj;
    
  }
}
