package core;
import org.omg.CORBA.Any;
import org.omg.CORBA.TCKind;
import  java.util.*;

public class gatekeeperImpl extends _gatekeeperImplBase
{
  
  protected Hashtable factoryRefs;
  org.omg.CORBA.ORB   orb;
  nameUtils NameServer;
  public  org.omg.CORBA.BOA boa;
  
public gatekeeperImpl(org.omg.CORBA.ORB orb_,
		      org.omg.CORBA.BOA boa_)
  {
    orb          = orb_;
    boa          = boa_;
    
    //create 3 contexts in name server 
    NameServer   = new nameUtils(orb);
    factoryRefs  = findFactoryRefs();
  }

public void trigger(String moduleName,String factoryName)
  {
    int lastDot = moduleName.lastIndexOf(".");
    String actorName = moduleName.substring(lastDot+1);

    //start execution of the first actor with name "actorName" at factory
    //with the name of "factoryName". There may be multiple copies of
    //one actor running at same factory
    actorName       = factoryName+"_"+actorName;//+"_0";
    actor itsActor = actorHelper.narrow(NameServer.findActor(actorName));
    itsActor.trigger();
    
  }
         
public Hashtable findFactoryRefs()
  {

    Hashtable result = new Hashtable ();
    Hashtable objs   =  NameServer.lookForNamesWithAttr("factory",3);
    Enumeration keyItems = objs.keys();
    while(keyItems.hasMoreElements()){
      String facName = (String)keyItems.nextElement();
      Object oneObj  = objs.get(facName);
      result.put(facName,moduleFactoryHelper.narrow((org.omg.CORBA.Object)oneObj));
    }
    return result;
  }
  
  //serverName ans actorName is equal. Do not confuse.
  //Here our servers are actors, data flow machines
public actor createModule(String moduleName,String factoryName)
  {
    moduleFactory itsFactory = (moduleFactory)factoryRefs.get(factoryName);
    //this may change in the future !!!!!!!!!!
    //moduleName is actual  full classname
    //For now let the last part of moduleName be serverName
    int lastDot = moduleName.lastIndexOf(".");
    String serverName = moduleName.substring(lastDot+1);
  
    //We may be producing same module on multiple factories.
    //So to make them unique name, prefix factory name to servername
    serverName        = factoryName+"_"+serverName;//+"_0";
    String className  = moduleName;
    actor oneActor = itsFactory.createProduct(className,serverName);
    return oneActor;
  }
  
public void connect(String fromModule, String toModule)
  {
    //fromModule = moduleName'+'Factoryname
    int plusPos = fromModule.indexOf("+");
    String moduleName  = fromModule.substring(0,plusPos);
    String factoryName = fromModule.substring(plusPos+1);
    actor fromActor    = createModule(moduleName,factoryName);
    
    plusPos = toModule.indexOf("+");
    moduleName  = toModule.substring(0,plusPos);
    factoryName = toModule.substring(plusPos+1);
    actor toActor    = createModule(moduleName,factoryName);
    int lastDot = moduleName.lastIndexOf(".");
    String actorName = moduleName.substring(lastDot+1);
    actorName        = factoryName+"_"+actorName;
        
    fromActor.connectTo(toActor,actorName);
        
  }
 
  //WE WILL IMPLEMENT THE FOLLOWING LATER
public moduleFactory createFactory(String factoryName)
  {
    //NOT IMPLEMENTED YET
    return null;
  }
  
public void killFactory(String factoryName)
  {
    moduleFactory itsFactory = (moduleFactory)factoryRefs.get(factoryName);
    itsFactory.destroy();
  }
  
public void killAllFactories()
  {
    Enumeration keyItems = factoryRefs.keys();
    while(keyItems.hasMoreElements()){
      String facName = (String)keyItems.nextElement();
      System.out.println("Gatekeeper kills factory:"+facName);
      try{
	killFactory(facName);
      }catch(org.omg.CORBA.COMM_FAILURE e){
	System.out.println("CORBA.COMM_FAILURE : Forget this exception !!!");
      }
      System.out.println("Gatekeeper KILLED factory:"+facName);
    }
    System.out.println("Gatekeeper killed ALL of factories");
  }

public void dispose()
  {
    try{
      boa.deactivate_impl(null);
    }catch(org.omg.CORBA.COMM_FAILURE e){
      System.out.println("CORBA.COMM_FAILURE : Forget this exception !!!");
    } 
  }
  

}
