// **********************************************************************
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package factory;

import org.omg.CORBA.*;
import java.io.*;


public class FactoryClient 
{
    //
    // Standalone program initialization
    //
    public static void main(String args[])
    {
	try
	{

	    Factory onefactory =null;
	  
            //
            // Create ORB
            //
            ORB orb = ORB.init(args, new java.util.Properties());

	    //find the Object & get its referrence    
	    nameUtils nutil = new nameUtils(orb);
	    onefactory = FactoryHelper.narrow(nutil.findServer("FactoryServer"));
	    System.out.println("I got FactoryServer Object!!!");
	    	   	    
	    //
	    // Main loop
	    //
	    System.out.println("Enter 'c' for new product 'l' for list names or 'x' for exit:");

	    int c = 0;
	    try
	    {
		String input;
		do
		{
		    System.out.print("> ");
		    DataInputStream dataIn = new DataInputStream(System.in);
		    BufferedReader in =
			new BufferedReader(new InputStreamReader(dataIn));
		    input = in.readLine();

		    if (input.equals("c")){
		      onefactory.createProduct("hello.Hello_impl",
					       "HelloServer"+c);
		      c++;
		    }
		    else if (input.equals("l"))
		      nutil.lookForNamesWithAttr("service",1);
		    
		    
		}
		while(!input.equals("x"));
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't read from `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    System.exit(0);
	}
	catch(COMM_FAILURE ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
      
}
