// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package factory;

import org.omg.CORBA.*;
import java.io.*;

public class FactoryServer
{
    public static void main(String args[])
    {
	try
	{
            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, new java.util.Properties());
	    BOA boa = orb.BOA_init(args, new java.util.Properties());

	    //
	    // Create implementation object
	    //
	    FactoryImpl factory_impl = new FactoryImpl(orb, boa);
            
	    //Named Servant
	    //Register object to Name Server
	    nameUtils nutil = new nameUtils(orb);
	    nutil.registerName("FactoryServer",factory_impl);
	    System.out.println("I registered HelloWorld Servlet !!!");
	    
	    // Run implementation
	    boa.impl_is_ready(null);

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
    
}

