package factory;
   
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
   

public class nameUtils 
{
  ORB orb;
  NamingContext nc = null;
  NamingContext FactoriesContext,ActorsContext,EventChannelsContext;
  
public nameUtils(ORB orb_)
  {
     orb = orb_;
     try{  
       nc = NamingContextHelper.narrow(
			      orb.resolve_initial_references("NameService") );
     }catch(org.omg.CORBA.ORBPackage.InvalidName e){
       System.out.println("We could not found nameServer:"+e);
     }
     FactoriesContext = registerContext("Factory","factory");
     ActorsContext   = registerContext("Actor","actor");
     EventChannelsContext    = registerContext("EventContext","event");
  }

 public void registerName(String serverName,org.omg.CORBA.Object obj)
  {
    bindName(nc,serverName,obj);
  }

public void registerFactory(String factoryName,org.omg.CORBA.Object obj)
  {
    bindName(FactoriesContext,factoryName,obj);
  }

public void registerActor(String ActorName,org.omg.CORBA.Object obj)
  {
    bindName(ActorsContext,ActorName,obj);
  }

public void registerEventChannel(String eventChannelName,
				 org.omg.CORBA.Object obj)
  {
    bindName(EventChannelsContext,eventChannelName,obj);
  }

  
 public void bindName(NamingContext nc,
		      String serverName,org.omg.CORBA.Object obj)
  {

    try{
      NameComponent[] oneName = new NameComponent[1];
      oneName[0] = new NameComponent( serverName,"service");
      nc.bind(oneName, obj);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println(")");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound ex)
      {
	System.err.println("Got an `AlreadyBound' exception");
	ex.printStackTrace();
	
      }
    
  }
  

public NamingContext registerContext(String contextName,String kind)

  {
    NamingContext new_nc = null;  
    try{
      NameComponent[] oneName = new NameComponent[1];
      oneName[0] = new NameComponent( contextName,kind);
      new_nc = nc.bind_new_context(oneName);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println(")");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound ex)
      {
	System.err.println("Got an `AlreadyBound' exception");
	ex.printStackTrace();
	
      }
    return new_nc;
    
  }

public  org.omg.CORBA.Object findServer(String serverName)
  {
    org.omg.CORBA.Object obj = findObject(nc,serverName,"service");
    return obj;
  }

public org.omg.CORBA.Object findFactory(String factoryName)
  {
    org.omg.CORBA.Object obj = findObject(FactoriesContext,
					  factoryName,"factory");
    return obj;
  }

public org.omg.CORBA.Object findActor(String ActorName)
  {
    org.omg.CORBA.Object obj = findObject(ActorsContext,
					  ActorName,"factory");
    return obj;
  }

public org.omg.CORBA.Object findEventChannel(String eventChannelName)
  {
    org.omg.CORBA.Object obj = findObject(EventChannelsContext,
					  eventChannelName,"event");
    return obj;
  }

  public  org.omg.CORBA.Object findObject(NamingContext nc,
					  String name,String kind)
  {
    
    org.omg.CORBA.Object obj = null;
	    
    // find an object (standard COSS naming interface)
    NameComponent[] components = new NameComponent[1];
    components[0] = new NameComponent(name,kind);
    try{
      obj = nc.resolve(components);
    }catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){
      System.out.println("InvalidName:"+name+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){
      System.out.println("CannotProceed :"+name+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound e){
      System.out.println("NotFound:"+name+":"+e);
    }
    return obj;
       
  }
    
  public  org.omg.CORBA.Object[] lookForNamesWithAttr(String objkind,
						      int howMany)
  {
    NamingContext nc=null;
    Vector objs = new Vector();
    org.omg.CORBA.Object oneobj;
    BindingListHolder bList= new BindingListHolder();
    BindingIteratorHolder bIter= new BindingIteratorHolder();

    if (objkind.equals("factory"))
      nc =  FactoriesContext;
    else if (objkind.equals("actor"))
      nc = ActorsContext;
    else if (objkind.equals("event"))
      nc = EventChannelsContext ;
    
    nc.list(howMany,bList,bIter);
    for(int i=0;i<bList.value.length;i++){
      System.out.println("Name:"+bList.value[i].binding_name[0].id+
			 "Kind:"+ bList.value[i].binding_name[0].kind);
      oneobj = findObject(nc,bList.value[i].binding_name[0].id,
			  bList.value[i].binding_name[0].kind);
      objs.addElement(oneobj);
    }
 
    if (bIter != null){
      BindingIterator bi = bIter.value;
      while(bi.next_n(howMany,bList)){
	for(int i=0;i<bList.value.length;i++){
	  System.out.println("Name:"+bList.value[i].binding_name[0].id+
			     "Kind:"+ bList.value[i].binding_name[0].kind);
	  oneobj = findObject(nc,bList.value[i].binding_name[0].id,
			      bList.value[i].binding_name[0].kind);
	    objs.addElement(oneobj);
	}
      }
    }
   
    //store the result
    org.omg.CORBA.Object []result = new org.omg.CORBA.Object[objs.size()];
    for(int i=0;i<objs.size();i++)
      result[i] = (org.omg.CORBA.Object)objs.elementAt(i);
    
    return result;
    
  }
  
  

}


