// **********************************************************************
//
// Generated by the ORBacus IDL to Java Translator
//
// Copyright (c) 1998
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1998
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

// Version: 3.0b1
// License: non-commercial

package chat;

//
// IDL:Broadcaster:1.0
//
/**
 *
 * An interface which is used to broadcast messages to multiple
 * receivers.
 *
 * This interface must be implemented by the chat server. It provides
 * operations for connecting and disconnecting chat clients
 * (i.e. receivers). It also provides operations that chat clients can
 * use to send messages to all other connected clients.
 *
 * @see Receiver
 *
 **/
public interface Broadcaster extends org.omg.CORBA.Object
{

    //
    // IDL:Broadcaster/register:1.0
    //
    /**
     *
     * Register a receiver (chat client).
     *
     * Chat clients must use this function to register with the chat
     * server (broadcaster) in order to receive messages from
     * the chat server.
     *
     * @param receiver The receiver which wants to register itself.
     *
     * @param id The receiver's user id.
     *
     * @param host The receiver's host name.
     *
     * @param nick The receiver's nick name.
     *
     * @exception chat.BroadcasterPackage.AlreadyRegistered Raised if a receiver tries to
     * register more than once.
     *
     * @exception chat.BroadcasterPackage.NickExists Raised if the requested nick name is
     * already in use.
     *
     **/
    public void
    register(Receiver receiver,
             String id,
             String host,
             String nick)
        throws chat.BroadcasterPackage.AlreadyRegistered,
               chat.BroadcasterPackage.NickExists;

    //
    // IDL:Broadcaster/registerWithCheck:1.0
    //
    /**
     *
     * Register a receiver (chat client) with callback check.
     *
     * This operations behaves like <code>register</code>, except that
     * it tries to call back the receiver and throws a
     * <code>ReceiverUnreachable</code> exception if it can't reach
     * the receiver, for example due to firewall or nameserver
     * problems.
     *
     * @param receiver The receiver which wants to register itself.
     *
     * @param id The receiver's user id.
     *
     * @param host The receiver's host name.
     *
     * @param nick The receiver's nick name.
     *
     * @exception chat.BroadcasterPackage.ReceiverUnreachable Raised if for some reason the
     * chat server cannot call back to the chat client.
     *
     * @exception chat.BroadcasterPackage.AlreadyRegistered Raised if a receiver tries to
     * register more than once.
     *
     * @exception chat.BroadcasterPackage.NickExists Raised if the requested nick name is
     * already in use.
     *
     **/
    public void
    registerWithCheck(Receiver receiver,
                      String id,
                      String host,
                      String nick)
        throws chat.BroadcasterPackage.ReceiverUnreachable,
               chat.BroadcasterPackage.AlreadyRegistered,
               chat.BroadcasterPackage.NickExists;

    //
    // IDL:Broadcaster/unregister:1.0
    //
    /**
     *
     * Unregister a receiver (chat client).
     *
     * Chat clients must use this function to unregister with the chat
     * server (broadcaster) before they disconnect.
     *
     * @param receiver The receiver which wants to register itself.
     *
     * @exception chat.BroadcasterPackage.UnknownReceiver Raised if the receiver is not
     * registered.
     *
     **/
    public void
    unregister(Receiver receiver)
        throws chat.BroadcasterPackage.UnknownReceiver;

    //
    // IDL:Broadcaster/setNickName:1.0
    //
    /**
     *
     * Set a receiver's nick name.
     *
     * @param receiver The receiver which wants to set its nick name.
     *
     * @param nick The nick name.
     *
     * @exception chat.BroadcasterPackage.UnknownReceiver Raised if the receiver is not
     * registered.
     *
     * @exception chat.BroadcasterPackage.NickExists Raised if the requested nick name is
     * already in use.
     *
     **/
    public void
    setNickName(Receiver receiver,
                String nick)
        throws chat.BroadcasterPackage.UnknownReceiver,
               chat.BroadcasterPackage.NickExists;

    //
    // IDL:Broadcaster/getReceiverByNick:1.0
    //
    /**
     *
     * Set a receiver description by its nick name.
     *
     * @param nick The nick name.
     *
     * @param desc The receiver description.
     *
     * @exception chat.BroadcasterPackage.UnknownNick Raised if the nick name is not known.
     *
     **/
    public void
    getReceiverByNick(String nick,
                      chat.BroadcasterPackage.ReceiverDescriptionHolder desc)
        throws chat.BroadcasterPackage.UnknownNick;

    //
    // IDL:Broadcaster/getReceiverNames:1.0
    //
    /**
     *
     * Get all receiver names.
     *
     * @return A string sequence containing all receiver names.
     *
     **/
    public String[]
    getReceiverNames();

    //
    // IDL:Broadcaster/say:1.0
    //
    /**
     *
     * Say something to all registered chat clients (receivers).
     *
     * @param text The message text.
     *
     **/
    public void
    say(String text);
}
