// Server.java
package core;

import java.util.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.*;
import java.net.*;
import java.io.*;

public class GKeeper extends _gatekeeperImplBase
{
  org.omg.CORBA.ORB orb;
  Hashtable factoryProxies,actorProxies;
  String []args;
    
  public GKeeper(String []args_)
  {
    factoryProxies = new Hashtable();
    actorProxies   = new Hashtable();
    orb = ORB.init(args_, new java.util.Properties());
    args = args_;
    
  }
  

  //Create factory with name "factoryName" at "Url" WWW address
  public Proxy  createFactory(String factoryName,String Url)
  {
    String FACTORY_SERVLET = "/servlet/objectfactory";
    String FAC_URL         = Url+FACTORY_SERVLET;
    String request         = FAC_URL+"?cmd="+factoryName;
    String s = "",sin;
    BufferedReader bufread;
        
    try{
      URL url = new URL(request); 
      URLConnection ucon = url.openConnection();
      bufread=new BufferedReader(new InputStreamReader(ucon.getInputStream()));
      s += bufread.readLine();
      while((sin=bufread.readLine()) != null)
	s += sin;
    }catch (MalformedURLException ev)
      {
	System.out.println("URL error in getting IOR of factory: " + ev);
	return null;
      }
    catch (IOException ev)
      {
	System.out.println("IOException in getting IOR of factory:"+ev);
	return null;
      }
    System.out.println("I got IOR of factory :"+s);

    //translate IOR string to factory Object 
    org.omg.CORBA.Object fac_obj = null;
    try{
      fac_obj = orb.string_to_object(s);
    }catch( org.omg.CORBA.INV_OBJREF e){
      System.out.println("We could'nt string_to_object for :"+s+" :"+e);
      return null;
    }
    
    //Create new proxy object for created factory at Applet server host
    Proxy proxy = new Proxy_Impl(fac_obj,factoryName,args);
    //connect it to object adapter
    orb.connect(fac_obj);

    //add the factory name and its Reference to hashtable
    factoryProxies.put(factoryName,fac_obj);
    
    //return created proxy to Applet Client
    return proxy;
  }

/* kill all proxies it created */
public void killAllProxies()
  {
  }
  
/* kill itself */
  public void dispose()
  {
  }
  
}

class Proxy_Impl  extends  org.omg.CORBA.DynamicImplementation
                 implements Proxy
 {
  org.omg.CORBA.Object obj;  
  String obj_name;
  org.omg.CORBA.ORB orb;
  Hashtable interfacedef;
  
  static final String[] _ob_ids_ =
    {
        "IDL:core/Proxy:1.0",
    };
 
    public String[]
    _ids()
    {
      return _ob_ids_;
    }

public Proxy_Impl(org.omg.CORBA.Object obj_,String obj_name_,String []args)
  {
    obj          = obj_;
    obj_name     = obj_name_;
    orb          = ORB.init(args, new java.util.Properties());
    interfacedef = new Hashtable();

    /* store signatures of the actual object of this proxy */
    getInterfaceDesc();
  }
  
public void dispose()
  {
    
    
  }

public boolean isItValidRequest(String opname)
  {
    //Put here to check some available methods
    return true;
    
  }
   
public void invoke(org.omg.CORBA.ServerRequest request) 
  {
    String opname = request.op_name();
    
    //If the requested operation is not supported this proxy's actual object
    //throw exception
    OperationDescription opdef = interfacedef.get(opname);
    if (opdef == null)
      throw new org.omg.CORBA.BAD_OPERATION();
    
    org.omg.CORBA.NVList params = orb.create_list(0);
    ParameterDescription []pramsdefs = opdef.parameters;
    for(int k=0;k<paramdefs.length;k++)
      {
	org.omg.CORBA.Any nameAny = orb.create_any();
	TypeCode type = paramdefs[k].type;
	nameAny.type(orb.get_primitive_tc(type));
	String name = paramdefs[k].name;
	org.omg.CORBA.Any.ParameterMode mode = paramdefs[k].mode;
	params.add_value(name, nameAny, mode);
      }
    // obtains the params from the request
    request.params(params);

    //forward the request to its actual object
    org.omg.CORBA.Any nameAny = orb.create_any();
    TypeCode result_type = opdef.result;
    nameAny.type(result_type);
    NamedValue result = orb.create_named_value("",nameAny,
					       org.omg.CORBA.ARG_OUT);
    Request forward_request = obj._create_request(get_default_context(),
						    opname,params,result);
    forward_request.invoke();
    
    // create an any for the result
    org.omg.CORBA.Any resultAny = orb.create_any();
    resultAny.type(
    // put in the received value from actual object
    accountAny.insert_Object(account);
    // set the request's result
    request.result(accountAny);
  }
  
public void getInterfaceDesc()
  {
    InterfaceDef idef = obj._get_interface();
    FullInterfaceDescription fis = idef.describe_interface();
    //System.out.println("interface name :"+fis.name);
    //System.out.println("interface id:"+fis.id);
    //System.out.println("interface defined_in:"+fis.defined_in);
 
    OperationDescription []ods = fis.operations;
    for(int k=0;k<ods.length;k++){
      OperationDescription kops = ods[k];
      interfacedef.put(kops.name,kops);
      //System.out.println("Operation name:"+kops.name);
      //System.out.println("Operation result type:"+kops.result);
      //System.out.println("Operation mode:"+kops.mode);
      ParameterDescription []pds = kops.parameters;
      for(int j=0;j<pds.length;j++){
        //System.out.println("Parameter name:"+pds[k].name);
        //System.out.println("Parameter type:"+pds[k].type);
        //System.out.println("Parameter idsltype:"+pds[k].type_def);
        //System.out.println("Parameter mode:"+pds[k].mode);
      }
    }
  }

}

