// Server.java
import Bank.nameUtils;


import java.util.*;
import org.omg.CORBA.InterfaceDefPackage.*;
import org.omg.CORBA.*;

class Account extends org.omg.CORBA.DynamicImplementation {
  static final String[] _ob_ids_ =
    {
        "IDL:Bank/Account:1.0",
    };
 
    public String[]
    _ids()
    {
        return _ob_ids_;
    }

  Account(float balance) {
    //super(null, "IDL:Bank/Account:1.0");
    _balance = balance;
  }
  public void invoke(org.omg.CORBA.ServerRequest request) {
    // make the operation name is correct
    if(!request.op_name().equals("balance")) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    // no parameters, so simply invoke the balance operation
    float balance = this.balance();
    // create an any for the result
     org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
    org.omg.CORBA.Any balanceAny = _ob_orb.create_any();
    // put in the balance, 
    balanceAny.insert_float(balance);
    // set the request's result
    request.result(balanceAny);
  }  
  float balance() {
    return _balance;
  }
  private float _balance;
}

class AccountManager extends org.omg.CORBA.DynamicImplementation {
  static final String[] _ob_ids_ =
    {
        "IDL:Bank/AccountManager:1.0",
    };
 
    public String[]
    _ids()
    {
        return _ob_ids_;
    }
  AccountManager(String name) {
    //test
    // create an empty parameter list
    //org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
    //nameUtils nu = new nameUtils(_ob_orb);
    //org.omg.CORBA.portable.ObjectImpl hello = (org.omg.CORBA.portable.ObjectImpl)nu.findName(  "HelloServer","service");
    //_set_delegate(hello._get_delegate());
    //org.omg.CORBA.InterfaceDef idef = _get_interface();
    //printIntDesc(idef);    
    //test

    //super(name, "IDL:Bank/AccountManager:1.0");
  }
  public void invoke(org.omg.CORBA.ServerRequest request) {
    // make the operation name is correct
    if(!request.op_name().equals("open")) {
      throw new org.omg.CORBA.BAD_OPERATION();
    }
    // create an empty parameter list
    org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();

    //test something
    org.omg.CORBA.InterfaceDef idef =  _get_interface();
    printIntDesc(idef);
    org.omg.CORBA.portable.Delegate del = _get_delegate();
    if (del != null){
      System.out.println("delegate is not null !!!");
      if(!del.non_existent(this))
	System.out.println("it is not existent !!!");
    }

    
    //del = (Delegate)_get_delegate();
    //nameUtils nu = new nameUtils(_ob_orb);
    //org.omg.CORBA.portable.ObjectImpl hello = (org.omg.CORBA.portable.ObjectImpl)nu.findName(  "HelloServer","service");
    //idef =  hello._get_interface();
    //printIntDesc(idef);    
    //test


    org.omg.CORBA.NVList params = _ob_orb.create_list(0);
    // create an any for the name parameter
    org.omg.CORBA.Any nameAny = _ob_orb.create_any();
    // set the any's type to be a string
    nameAny.type(_ob_orb.get_primitive_tc(
		org.omg.CORBA.TCKind.tk_string));
    // add "in" the parameter to the parameter list
    params.add_value("name", nameAny, org.omg.CORBA.ARG_IN.value);
    // obtains the params from the request
    request.params(params);
    // get the name parameter from the any
    String name = nameAny.extract_string();

    // invoke the open operation
    Account account = this.open(name);

    //test 
    //org.omg.CORBA.ImplementationDef impl = _get_implementation();
    //Bank.AccountManager accountman = Bank.AccountManagerHelper.narrow(impl);
    //Bank.Account account = accountman.open(name);
    //test

    // create an any for the result
    org.omg.CORBA.Any accountAny = _ob_orb.create_any();
    // put in the new account object
    accountAny.insert_Object(account);
    // set the request's result
    request.result(accountAny);
  }
  public synchronized Account open(String name) {
    // Lookup the account in the account dictionary.
    Account account = (Account) _accounts.get(name);
    if(account == null) {
      // Create a new account with between 0 and 1000 dollars.
      float balance = Math.abs(_random.nextInt()) % 100000 / 100f;
      account = new Account(balance);
      // Export the new object reference.
      org.omg.CORBA.ORB _ob_orb = org.omg.CORBA.ORB.init();
      //org.omg.CORBA.BOA _ob_boa = _ob_orb.BOA_init();
      //_ob_boa.impl_is_ready(null);//account);
      System.out.println("Created " + name + "'s account: " + account);
      // Save the account in the account dictionary.
      _accounts.put(name, account);
    }
    // Return the account.
    return account;
  }

  public void printIntDesc(InterfaceDef idef)
  {
    FullInterfaceDescription fis = idef.describe_interface();
    System.out.println("interface name :"+fis.name);
    System.out.println("interface id:"+fis.id);
    System.out.println("interface defined_in:"+fis.defined_in);
 
    OperationDescription []ods = fis.operations;
    for(int k=0;k<ods.length;k++){
      OperationDescription kops = ods[k];
      System.out.println("Operation name:"+kops.name);
      System.out.println("Operation result type:"+kops.result);
      System.out.println("Operation mode:"+kops.mode);
      ParameterDescription []pds = kops.parameters;
      for(int j=0;j<pds.length;j++){
        System.out.println("Parameter name:"+pds[k].name);
        System.out.println("Parameter type:"+pds[k].type);
        System.out.println("Parameter idsltype:"+pds[k].type_def);
        System.out.println("Parameter mode:"+pds[k].mode);
      }
    }
 
  }

  private Dictionary _accounts = new Hashtable();
  private Random _random = new Random();
}

public class Server1 {
  public static void main(String[] args) {
    // Initialize the ORB.
    org.omg.CORBA.ORB orb = org.omg.CORBA.ORB.init(args,new java.util.Properties());
    // Initialize the BOA.
    org.omg.CORBA.BOA boa = orb.BOA_init(args,null);
    // Create the account manager object.
    AccountManager manager = 
      new AccountManager("BankManager");
    nameUtils nu = new Bank.nameUtils(orb);
    nu.registerName("manager","",manager);
    
    // Export the newly create object.
    boa.impl_is_ready(null);
    System.out.println(manager + " is ready.");
    // Wait for incoming requests
    boa.impl_is_ready(null);
  }

}

