import core.*;
import org.omg.CORBA.*;
import java.io.*;
import java.awt.event.*;
import com.sun.java.swing.*;
import com.sun.java.swing.event.*;
import java.awt.*;
public class objflowtest
{
  public static JButton connectB,triggerB,killFactoryB,killAllFactoryB;
  public static JButton killGateKeeperB;
  
  public static JComboBox fromModule,fromFactory,toModule,toFactory;
  
  public static void main(String []args)
  {
    JPanel panel = new JPanel();
    panel.setLayout(new BorderLayout());

    JPanel mpanel = new JPanel();
    mpanel.setLayout(new FlowLayout());

    //From Module and factory 
    fromModule = new JComboBox();
    fromModule.setEditable(true);
    for(int k=0;k<5;k++)
      {
	fromModule.addItem("module.test.adder"+"_"+k);
	fromModule.addItem("module.test.multiply"+"_"+k);
	fromModule.addItem("module.test.substruct"+"_"+k);
	fromModule.addItem("module.test.number"+"_"+k);
      }
    
    mpanel.add(fromModule);
    
    fromFactory = new JComboBox();
    fromFactory.setEditable(true);
    fromFactory.addItem("first_factory");
    fromFactory.addItem("second_factory");
    mpanel.add(fromFactory);

    //To Module and factory 
    toModule = new JComboBox();
    toModule.setEditable(true);
    for(int k=0;k<5;k++)
      {
	toModule.addItem("module.test.adder"+"_"+k);
	toModule.addItem("module.test.multiply"+"_"+k);
	toModule.addItem("module.test.substruct"+"_"+k);
	toModule.addItem("module.test.number"+"_"+k);
      }   
    
    mpanel.add(toModule);
    
    toFactory = new JComboBox();
    toFactory.setEditable(true);
    toFactory.addItem("first_factory");
    toFactory.addItem("second_factory");
    mpanel.add(toFactory);
    panel.add(mpanel,BorderLayout.CENTER);
    

    final ActorProxy actorproxy = new ActorProxy(args);
    
    JPanel bpanel = new JPanel();
    bpanel.setLayout(new FlowLayout());

    connectB = new JButton("connect");
    bpanel.add(connectB );
    connectB.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e)
       {
	 String fromM = (String)fromModule.getSelectedItem();
	 String fromF = (String)fromFactory.getSelectedItem();
	 String toM   = (String)toModule.getSelectedItem();
	 String toF   = (String)toFactory.getSelectedItem();
	 actorproxy.connectModules(fromM,fromF,toM,toF);
       }
    });

  
    triggerB = new JButton("triggerB");
    bpanel.add(triggerB );
    triggerB.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e)
       {
	 String fromM = (String)fromModule.getSelectedItem();
	 String fromF = (String)fromFactory.getSelectedItem();
	 actorproxy.triggerModule(fromM,fromF);
       }
    });

    killFactoryB = new JButton("killFactory");
    bpanel.add(killFactoryB );
    killFactoryB.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e)
       {
	 String fromF = (String)fromFactory.getSelectedItem();
	 actorproxy.killFactory(fromF);
       }
    });

    killAllFactoryB = new JButton("killAllFactory");
    bpanel.add(killAllFactoryB );
    killAllFactoryB.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e)
       {
	 String fromF = (String)fromFactory.getSelectedItem();
	 actorproxy.killAllFactories();
       }      
    });

    killGateKeeperB = new JButton("killGateKeeper");
    bpanel.add(killGateKeeperB );
    killGateKeeperB.addActionListener(new ActionListener() {
     public void actionPerformed(ActionEvent e)
       {
	 actorproxy.killGateKeeper();
	 
       }      
    });

    panel.add(bpanel,BorderLayout.SOUTH);

    JFrame frame = new JFrame("TreeDemo");
    frame.getContentPane().setLayout( new BorderLayout() );
    frame.getContentPane().add(BorderLayout.CENTER,panel);
    frame.setSize(600,600);
    frame.show();

  }
  
  
}

class ActorProxy
{
   ORB orb ;
   nameUtils NameServer;
   gatekeeper gateProxy;
  
   public ActorProxy(String []args)
   {
     orb = ORB.init(args, new java.util.Properties());

     //find the Gatekeeper Object & get its referrence
     nameUtils NameServer = new nameUtils(orb);
     gateProxy = gatekeeperHelper.narrow(
		       	 NameServer.findName("gatekeeper","gkeeper"));
   }
  
public void connectModules(String fromModule, String fromFactory,
			   String toModule, String toFactory)
  {
    fromModule = fromModule+"+"+fromFactory;
    toModule   = toModule+"+"+toFactory;
    System.out.println("I make connection from "+fromModule+" to "+toModule);
    gateProxy.connect(fromModule,toModule);
    System.out.println("I DID connection from "+fromModule+" to "+toModule);   
  }
  
  
public void triggerModule(String moduleName,String factoryName)
  {
    System.out.println("I trigger: "+moduleName+"("+factoryName+")");
    gateProxy.trigger(moduleName,factoryName);
    System.out.println("I DID trigger: "+moduleName+"("+factoryName+")");
  }

public void killFactory(String  factoryName)
  {
    System.out.println("I kill factory :"+ factoryName);
    gateProxy.killFactory(factoryName);
    System.out.println("I DID kill factory :"+ factoryName);
    
  }
  
public void killAllFactories()
  {
    System.out.println("I kill factories ");
    gateProxy.killAllFactories();
    System.out.println("I DID kill factories ");
    
  }     

public void killGateKeeper()
  {
    System.out.println("Kill gatekeepr !!!");
    gateProxy.dispose();
       
  }
  
}
