package core;
import org.omg.CORBA.Any;
import org.omg.CORBA.TCKind;
import  java.util.*;

public abstract class actorImpl extends _actorImplBase
{
  protected Hashtable incomingVals;
  protected Hashtable  InPort,OutPort;
  org.omg.CORBA.ORB   orb;
  protected String myName;
  int InConns,OutConns;
  int numOfInput ;
  nameUtils NameServer;
    
public actorImpl(org.omg.CORBA.ORB orb_,String myName_)
  {
    incomingVals = new Hashtable();
    InPort       = new Hashtable();
    OutPort      = new Hashtable();
    orb          = orb_;
    NameServer   = new nameUtils(orb);
    myName       = myName_;
    InConns      = 0;
    OutConns     = 0;
    numOfInput   = 0;
    
  }
  
public void connectTo(actor toActor,String actorName)
  {
    OutPort.put(actorName,toActor);
    toActor.connectFrom(this,myName);
    OutConns++;
  }
  
public void connectFrom(actor fromActor,String actorName)
  {
    InPort.put(actorName,fromActor);
    fromActor.connectTo(this,myName);
    InConns++;
  }

public void disconnectTo(actor toActor,String actorName)
  {
    OutPort.remove(actorName);
    toActor.disconnectFrom(this,myName);
    OutConns--;
  }
  
public void disconnectFrom(actor fromActor,String actorName)
  {
    InPort.remove(actorName);
    fromActor.disconnectTo(this,myName);
    InConns--;
  }

public abstract  Any  compute(Hashtable inputTable);
  
public void  readIncoming(String actorName,Any input)
  {
    incomingVals.put( actorName,input);
    numOfInput ++;
    //We received data  from all of the input ports and do calculation
    if ((InConns > 0) && (numOfInput == InConns)){
      Any result = compute(incomingVals);
      Enumeration targets = OutPort.elements();
      while(targets.hasMoreElements()){
	actor dest = (actor)targets.nextElement();
	dest.readIncoming(myName,result);
      }
    }
  }
  
public void destroy()
  {
    NameServer.unregisterActor(myName);
    orb.disconnect(this);
  }
  
}
