package core;
import java.util.*;
import java.lang.*;
import java.lang.reflect.*;
   
public class moduleFactoryImpl  extends _moduleFactoryImplBase
{
  org.omg.CORBA.ORB orb;
  org.omg.CORBA.BOA boa;
  String myName;
  Hashtable products;
  nameUtils NameServer;
  String []args;
  
  public moduleFactoryImpl(org.omg.CORBA.ORB orb_,
			   org.omg.CORBA.BOA boa_, 
			   String myName_,String []args_)
  {
    orb = orb_;
    boa = boa_;
    myName = myName_;
    products = new Hashtable();
    NameServer   = new nameUtils(orb);
    args = args_;
    
  }

public String incIndex(String serverName)
  {
    int LUScore = serverName.lastIndexOf("_");
    int newIndex = Integer.parseInt(serverName.substring(LUScore+1));
    String newServerName = serverName.substring(0,LUScore+1)+newIndex;
    return newServerName;
       
  }
  

  public actor createProduct(String className,String serverName)
  {
    Class implClass       = null;
    org.omg.CORBA.Object obj  = null;
    Constructor[] constructors = null;
    
    System.out.println("Factory:"+myName+" makes new product with classname:"+
		       className+" server:"+serverName);
    
    //eliminate index of class name at the end
    int LUScore = className.lastIndexOf("_");
    className  = className.substring(0,LUScore);
    
    Object itsRef = products.get(serverName);
    if (itsRef != null)
      return (actor)itsRef;
    
    try{
      implClass = Class.forName(className);
      constructors = implClass.getConstructors();
    }catch(ClassNotFoundException e){
      System.out.println("ClassNotFoundException : "+className+": "+e);
    }
     
    try{  
      Object []initArgs = {serverName,args } ;
      obj = (org.omg.CORBA.Object)constructors[0].newInstance(initArgs) ;
    }catch (IllegalAccessException e){
      System.out.println("IllegalAccessException :"+className+": "+e);
    }
    catch(InstantiationException e){
      System.out.println("InstantiationException :"+className+": "+e);
    } 
    catch(InvocationTargetException e){
      System.out.println("InvocationTargetException: "+className+": "+e);
    }
    catch(IllegalArgumentException e){
      System.out.println("IllegalArgumentException: "+className+": "+e);
    }
    
 
    //connect it to object adapter
    orb.connect(obj);

    //register it to name server
    boolean result = NameServer.registerActor(serverName,obj);
    System.out.println("REGISTER it:server:"+serverName+
		       "to name server:classname:"+className);

    //add into product hash table
    products.put(serverName,obj);

    //return the created product,one actor
    return (actor)obj;
    
  }

  //disconnect factory and its products
  public void disconnect_factory()
  {
    System.out.println("Factory :"+myName+" is destroying itself");
    
    //unregister from Name Server
    NameServer.unregisterFactory(myName);
    //First disconnect all of its products 
    Enumeration actorProducts = products.elements();
    while(actorProducts.hasMoreElements()){
      System.out.println("Factory :"+myName+" destroy its product:");
      actor itsActor = actorHelper.narrow((org.omg.CORBA.Object)
					  actorProducts.nextElement());
      itsActor.destroy();
    }
    System.out.println("Factory :"+myName+" FINALLY destroys itself");
    //finally destroy itsel
    orb.disconnect(this);
  }

  //kill the factory and all of its products
   public void destroy()
  {
    System.out.println("Factory :"+myName+" is destroying itself");
    
    //unregister from Name Server
    NameServer.unregisterFactory(myName);
    //First disconnect all of its products 
    Enumeration actorProducts = products.elements();
    while(actorProducts.hasMoreElements()){
      System.out.println("Factory :"+myName+" destroy its product:");
      actor itsActor = actorHelper.narrow((org.omg.CORBA.Object)
					  actorProducts.nextElement());
      itsActor.destroy();
    }   
    System.out.println("Factory :"+myName+" FINALLY destroys itself");
    //finally destroy itself
    boa.deactivate_impl(null);
  }

 }
