package core;
   
import org.omg.CORBA.*;
import java.io.*;
import java.util.*;
import java.awt.event.*;
import org.omg.CosNaming.*;
import org.omg.CosNaming.NamingContextPackage.*;
   

public class nameUtils 
{
  ORB orb;
  NamingContext nc = null;
  NamingContext FactoriesContext,ActorsContext,EventChannelsContext;
  
public nameUtils(ORB orb_)
  {
     orb = orb_;
     try{  
       nc = NamingContextHelper.narrow(
			      orb.resolve_initial_references("NameService") );
     }catch(org.omg.CORBA.ORBPackage.InvalidName e){
       System.out.println("We could not found nameServer:"+e);
     }
     if (findName(nc,"Factory","factory") == null)
       {
	 FactoriesContext = registerContext("Factory","factory");
	 ActorsContext   = registerContext("Actor","actor");
	 EventChannelsContext    = registerContext("EventContext","event");
       }
     
  }
   
 public boolean registerName(String serverName,String kind,org.omg.CORBA.Object obj)
  {
    String []Names = {serverName};
    String []kinds   = {kind};
    return (bindName(Names,kinds,obj));
  }

public boolean registerFactory(String factoryName,org.omg.CORBA.Object obj)
  {
    String []Names = {"Factory",factoryName};
    String []kinds   = {"factory","factory" };
    return (bindName(Names,kinds,obj));
  }

public boolean registerActor(String ActorName,org.omg.CORBA.Object obj)
  {
    String []Names = {"Actor",ActorName};
    String []kinds   = {"actor","actor"};
    return (bindName(Names,kinds,obj));
  }

public boolean registerEventChannel(String eventChannelName,
				 org.omg.CORBA.Object obj)
  {
    
    String []Names = {"EventContext",eventChannelName};
    String []kinds   = {"event","event"};
    return (bindName(Names,kinds,obj));
  }

  //////////////////////////////
 public void unregisterName(String serverName,String kind)
  {
    String []Names = {serverName};
    String []kinds   = {kind};
    unbindName(Names,kinds);
  }

public void unregisterFactory(String factoryName)
  {
    String []Names = {"Factory",factoryName};
    String []kinds   = {"factory","factory" };
    unbindName(Names,kinds);
  }

public void unregisterActor(String ActorName)
  {
    String []Names = {"Actor",ActorName};
    String []kinds   = {"actor","actor"};
    unbindName(Names,kinds);
  }

public void unregisterEventChannel(String eventChannelName)
  {
    String []Names = {"EventContext",eventChannelName};
    String []kinds   = {"event","event"};
    unbindName(Names,kinds);
  }

  
 public boolean bindName(String []Names, String []kinds, 
			 org.omg.CORBA.Object obj)
  {

    boolean result = true;
    System.out.println("I am registering Name_0:"+Names[0]+
		       " kind_0:"+kinds[0]);
    if (Names.length>1)
      System.out.println("I am registering Name_1:"+Names[1]+
			 " kind_1:"+kinds[1]);
    
    try{
      NameComponent[] oneName = new NameComponent[Names.length];
      for(int k=0;k<Names.length;k++)
	oneName[k] = new NameComponent(Names[k],kinds[k]);
      nc.bind(oneName, obj);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println(")");
	ex.printStackTrace();
	result = false;
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception");
	ex.printStackTrace();
	result = false;
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception");
	ex.printStackTrace();
	result = false;
      }
    catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound ex)
      {
	System.err.println("Got an `AlreadyBound' exception");
	ex.printStackTrace();
	result = false;
      }
    return result;
        
  }
  
public void unbindName(String []Names,String []kinds)
  {

    try{
      NameComponent[] oneName = new NameComponent[Names.length];
      for(int k=0;k<Names.length;k++)
	oneName[k] = new NameComponent(Names[k],kinds[k]);
      nc.unbind(oneName);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println(")");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception");
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception");
	ex.printStackTrace();
	
      }
    
  }
     

public NamingContext registerContext(String contextName,String kind)

  {
    NamingContext new_nc = null;  
    try{
      NameComponent[] oneName = new NameComponent[1];
      oneName[0] = new NameComponent( contextName,kind);
      new_nc = nc.bind_new_context(oneName);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound ex)
      {
	System.err.print("Got a `NotFound' exception (");
	switch(ex.why.value())
	  {
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._missing_node:
	    System.err.print("missing node");
	    break;
	    
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_context:
	    System.err.print("not context");
	    break;
 
	  case org.omg.CosNaming.NamingContextPackage.NotFoundReason._not_object:
	    System.err.print("not object");
	    break;
	  }
	System.err.println("):contextName"+contextName+" kind:"+kind);
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed ex)
      {
	System.err.println("Got a `CannotProceed' exception: contextName"+
			   contextName+" kind:"+kind);
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.InvalidName ex)
      {
	System.err.println("Got an `InvalidName' exception : contextName"+
			   contextName+" kind:"+kind);
	ex.printStackTrace();
	
      }
    catch(org.omg.CosNaming.NamingContextPackage.AlreadyBound ex)
      {
	System.err.println("Got an `AlreadyBound' exception : contextName"+
			   contextName+" kind:"+kind);
	ex.printStackTrace();
	
      }
    return new_nc;
    
  }
   
public org.omg.CORBA.Object findFactory(String factoryName)
  {
    String []Names = {"Factory",factoryName};
    String []kinds   = {"factory","factory" };
    org.omg.CORBA.Object obj = findObject(nc, Names,kinds);
    return obj;
  }

public org.omg.CORBA.Object findActor(String ActorName)
  {
    String []Names = {"Actor",ActorName};
    String []kinds   = {"actor","actor"};
    org.omg.CORBA.Object obj = findObject(nc, Names,kinds);
    return obj;
  }

public org.omg.CORBA.Object findEventChannel(String eventChannelName)
  {
    String []Names = {"EventContext",eventChannelName};
    String []kinds   = {"event","event"};
    org.omg.CORBA.Object obj = findObject(nc, Names,kinds);
    return obj;
  }

  public  org.omg.CORBA.Object findObject(NamingContext nc,
					  String []Names,String []kinds)
  {
    
    org.omg.CORBA.Object obj = null;
    // find an object (standard COSS naming interface)
    NameComponent[] components = new NameComponent[Names.length];
    for(int k=0;k<Names.length;k++)
      components[k] = new NameComponent(Names[k],kinds[k]);
    try{
      obj = nc.resolve(components);
    }catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){
      System.out.println("InvalidName:"+Names[0]+"&"+Names[1]+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){
      System.out.println("CannotProceed :"+Names[0]+"&"+Names[1]+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound e){
      System.out.println("NotFound:"+Names[0]+"&"+Names[1]+":"+e);
    }
    return obj;
  }


   public  org.omg.CORBA.Object findName( NamingContext nc,
					  String oName,String kind)
  {
    
    org.omg.CORBA.Object obj = null;
    // find an object (standard COSS naming interface)
    NameComponent[] components = new NameComponent[1];
    components[0] = new NameComponent(oName,kind);
    try{
      obj = nc.resolve(components);
    }catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){
      System.out.println("InvalidName:"+oName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){
      System.out.println("CannotProceed :"+oName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound e){
      System.out.println("NotFound:"+oName+":"+e);
    }
    return obj;
  }   

  public  org.omg.CORBA.Object findName(String oName,String kind)
  {
    
    org.omg.CORBA.Object obj = null;
    // find an object (standard COSS naming interface)
    NameComponent[] components = new NameComponent[1];
    components[0] = new NameComponent(oName,kind);
    try{
      obj = nc.resolve(components);
    }catch(org.omg.CosNaming.NamingContextPackage.InvalidName e){
      System.out.println("InvalidName:"+oName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.CannotProceed e){
      System.out.println("CannotProceed :"+oName+":"+e);
    }
    catch(org.omg.CosNaming.NamingContextPackage.NotFound e){
      System.out.println("NotFound:"+oName+":"+e);
    }
    return obj;
  }

public  Hashtable lookForNamesWithAttr(String objkind, int howMany)
  {
    NamingContext nnc=null;    
    Hashtable result = new Hashtable();
    org.omg.CORBA.Object oneobj,onc=null;
    BindingListHolder bList= new BindingListHolder();
    BindingIteratorHolder bIter= new BindingIteratorHolder();

    if (objkind.equals("factory"))
      onc =  findName(nc,"Factory","factory"); 
    else if (objkind.equals("actor"))
      onc = findName(nc,"Actor","actor"); 
    else if (objkind.equals("event"))
      onc = findName(nc,"EventContext","event");
    
    nnc = NamingContextHelper.narrow(onc);
    nnc.list(howMany,bList,bIter);
    for(int i=0;i<bList.value.length;i++){
      System.out.println("Name:"+bList.value[i].binding_name[0].id+
			 "Kind:"+ bList.value[i].binding_name[0].kind);
      oneobj = findName(nnc,bList.value[i].binding_name[0].id,
			  bList.value[i].binding_name[0].kind);
      result.put(bList.value[i].binding_name[0].id,oneobj);
    }
 
    if (bIter != null){
      BindingIterator bi = bIter.value;
      while((bi != null)&&(bi.next_n(howMany,bList))){
	for(int i=0;i<bList.value.length;i++){
	  System.out.println("Name:"+bList.value[i].binding_name[0].id+
			     "Kind:"+ bList.value[i].binding_name[0].kind);
  	  oneobj = findName(nnc,bList.value[i].binding_name[0].id,
			      bList.value[i].binding_name[0].kind);
	  result.put(bList.value[i].binding_name[0].id,oneobj);
	}
      }
    }

    //return result        
    return result;
    
  }
  
  

}


