//
// File: jacorb.demo.IntRep/Client.java
// An example for using the Interface Repository

package irep;
import org.omg.CORBA.*;
import org.omg.CORBA.InterfaceDefPackage.*;


public class Client 
{
public static void main( String[] args )
  {
    try
      {
	//
	// Create ORB and BOA
	//
	ORB orb = ORB.init(args, new java.util.Properties());
	BOA boa = orb.BOA_init(args, new java.util.Properties());

	nameUtils NameServer = new nameUtils(orb);
	
	// connect to the server object
	server s = serverHelper.narrow( NameServer.findName("IR-Example Server",""));

	// get the server object's interface definition
	// in the Interface Repository
	
	InterfaceDef i_def = ((org.omg.CORBA.Object)s)._get_interface();
	
	if( i_def != null ) 
	  {
	    System.out.println("ID: " + i_def.id() );
	    
	    FullInterfaceDescription fis = i_def.describe_interface();
	    printIntDesc(fis);
	    
	    // print it to the screen using the IdlWriter class
	    // (with an indentation of 2)
	    
	    //IdlWriter idlw = new IdlWriter(System.out);
	    //idlw.printInterface( i_def, 2  );
	  }
      } catch ( Exception e){
	e.printStackTrace();
      }
  }

  public static void printIntDesc(FullInterfaceDescription fis)
  {
    System.out.println("interface name :"+fis.name);
    System.out.println("interface id:"+fis.id);
    System.out.println("interface defined_in:"+fis.defined_in);
 
    OperationDescription []ods = fis.operations;
    for(int k=0;k<ods.length;k++){
      OperationDescription kops = ods[k];
      System.out.println("Operation name:"+kops.name);
      System.out.println("Operation result type:"+kops.result);
      System.out.println("Operation mode:"+kops.mode);
      ParameterDescription []pds = kops.parameters;
      for(int j=0;j<pds.length;j++){
	System.out.println("Parameter name:"+pds[k].name);
	System.out.println("Parameter type:"+pds[k].type);
	System.out.println("Parameter idsltype:"+pds[k].type_def);
	System.out.println("Parameter mode:"+pds[k].mode);
      }
    }
        
  }
  
}
