// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************

package hello;

import org.omg.CORBA.*;
import java.io.*;

public class Server
{
    public static void main(String args[])
    {
	try
	{
            //
            // Create ORB and BOA
            //
            ORB orb = ORB.init(args, new java.util.Properties());
	    BOA boa = orb.BOA_init(args, new java.util.Properties());

	    //
            // Get the OCI Current object
            //
            com.ooc.OCI.Current current = null;
            try
            {
                current = com.ooc.OCI.CurrentHelper.narrow(
                              orb.resolve_initial_references("OCICurrent"));
            }
            catch(org.omg.CORBA.ORBPackage.InvalidName e)
            {
                System.out.println("No OCI Currrent object");
                System.exit(1);
            }

            //
	    // Create implementation object
	    //
	    Hello_impl p = new Hello_impl(current);

	    //
	    // Save reference
	    //
	    try
	    {
		String ref = orb.object_to_string(p);
 		String refFile = "Hello.ref";
		FileOutputStream file = new FileOutputStream(refFile);
		PrintWriter out = new PrintWriter(file);
		out.println(ref);
		out.flush();
		file.close();
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't write to `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

	    //
	    // Save reference as html
	    //
	    try
	    {
		String ref = orb.object_to_string(p);
 		String refFile = "Hello.html";
		FileOutputStream file = new FileOutputStream(refFile);
		PrintWriter out = new PrintWriter(file);
		out.println("<applet codebase=\"classes\" " +
			    "code=\"hello/Client.class\" " +
			    "width=500 height=300>");
		out.println("<param name=ior value=\"" + ref + "\">");
		out.println("<param name=org.omg.CORBA.ORBClass " +
			    "value=com.ooc.CORBA.ORB>");
		out.println("<param name=org.omg.CORBA.ORBSingletonClass " +
			    "value=com.ooc.CORBA.ORBSingleton>");
		out.println("</applet>");
		out.flush();
		file.close();
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't write to `" +
				   ex.getMessage() + "'");
		System.exit(1);
	    }

            //
	    // Print host and port
	    //
	    com.ooc.OCI.AccRegistry registry =
		((com.ooc.CORBA.BOA)boa).get_acc_registry();
	    com.ooc.OCI.Acceptor[] acceptors = registry.get_acceptors();

	    for(int i = 0 ; i < acceptors.length ; i++)
	    {
		com.ooc.OCI.AcceptorInfo info = acceptors[i].get_info();
		com.ooc.OCI.IIOP.AcceptorInfo iiopInfo =
		    com.ooc.OCI.IIOP.AcceptorInfoHelper.narrow(info);

		if(iiopInfo != null)
		{
		    String host = iiopInfo.host();
		    int port = Converter.port(iiopInfo.port());

		    System.out.println("*** Running on host `" + host +
				       "', port number " + port);

		    //
		    // Add the accept callback object
		    //
                    com.ooc.OCI.AcceptCB acceptorCB = new AcceptCB_impl();
                    iiopInfo.add_accept_cb(acceptorCB);
		}
	    }

	    //
	    // Run implementation
	    //
	    boa.impl_is_ready(null);

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
}
