// **********************************************************************
//
// Copyright (c) 1997
// Object-Oriented Concepts, Inc.
// Billerica, MA, USA
//
// Copyright (c) 1997
// Object-Oriented Concepts GmbH
// Ettlingen, Germany
//
// All Rights Reserved
//
// **********************************************************************
 
package repository;

import repository.Module.*;
import org.omg.CORBA.*;
import java.io.*;

public class Server
{
    public static void main(String args[])
    {
	try
	{
	    //
	    // Create ORB and BOA
	    //
	    ORB orb = ORB.init(args, new java.util.Properties());
	    BOA boa = orb.BOA_init(args, new java.util.Properties());

	    //
	    // Create implementation object
	    //
	    Interface_impl p = new Interface_impl();

	    //
	    // Save reference
	    //
	    String ref = null;
	    try
	    {
		ref = orb.object_to_string(p);
 		String refFile = "Interface.ref";
		FileOutputStream file = new FileOutputStream(refFile);
                PrintWriter out = new PrintWriter(file);
		out.println(ref);
		out.flush();
		file.close();
	    }
	    catch(IOException ex)
	    {
		System.err.println("Can't open `" + ref +
				   "`: " + ex.getMessage());
		System.exit(1);
	    }

	    //
	    // Run implementation
	    //
	    boa.impl_is_ready(null);

	    System.exit(0);
	}
	catch(SystemException ex)
	{
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }
}
